package ru.ldeloff.servermonitorbot.service.role;

import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import ru.ldeloff.servermonitorbot.model.Role;
import ru.ldeloff.servermonitorbot.repository.RoleRepository;

import java.util.Locale;
import java.util.Optional;

@Service
@RequiredArgsConstructor
public class RoleServiceImpl implements RoleService {
    private final RoleRepository roleRepository;

    @Override
    public Role findRoleByName(String name) {
        Optional<Role> role = roleRepository.findRoleByName(name.toUpperCase(Locale.ROOT));
        //noinspection OptionalGetWithoutIsPresent
        return role.orElseGet(() -> roleRepository.findRoleByName("ANONYMOUS").get());
    }

    @Override
    public Role findRoleById(Long id) {
        Optional<Role> role = roleRepository.findRoleById(id);
        return role.orElseGet(() -> roleRepository.findRoleByName("ANONYMOUS").get());
    }
}
